/*
 ***** TODO *****
 */

// - Feature: Conversione delle usleep in nanosleep (piu- sicure in un ambiente ora multithread)
// - Feature: Guantare username (e gameserver) da /etc/joshua.rc o interattivamente (almeno se non esiste ancora)
// - Feature: Use robot / Use board - Non muove il robot e non aggiorna le viste (fast game) + Debug (dis)abilitabile da checkbox
// - Feature: Trasformazione di coordinate dal Game-Space allo Stepper-Space
// - Feature: Flag "need_refresh" in actor_game x non refreshare nei miss (buggy ?)
// - Feature: Pulsante Undo 
// - Bug: HISTORY partita nella codifica standard
// - Bug: Memory leaks hunter
// - Bug: Colori e testo della history si accatastano quando si gioca in 2 e si clicca a caso
// - Bug: SIGSEGV chiudendo gui durante autoplay
// - Bug: SIGSEGV verso la fine del secondo autoplay (non ripetibile facilmente) 
// - Bug: SIGSEGV al boot (non ripetibile facilmente) 
// - Bug: Stoppare cronometri allo scacco
// - Bug: Chiamare la torre R (Rook) e non T (Tower) - invece il cavallo resta H (Horse) e non K (Knight) x distinguerlo dal King
// - Bug: Actual player [0..1] nel gioco normale, [1..2] nell'autoplay (in autoplay stats actual_player color invertito)
// - Bug: 1 Player perde le mani (AI che non clicchi su ogni pedina sua, ma su quelle ke possono muovere, possibilmente mangiando)
// - Bug: in 1 player mode non deve muovere il robot sempre, ma solo quando muove il software
// - Bug: quando e' gia stata iniziata partita con 2 players e si passa all-autoplay la history si scolora e disassa
// - Bug: quando resetta dopo autoplay lascia la history (cancellabile con reset manuale), ma non le altre stats
// - SCACCO: non ti ci puoi mettere
// - SUPER BUG: Arrocco con re fuori posto crea una torre e un re in piu' e scambia i giocatori in "1 player mode" (arrocco da rifare)
// - PROPEDEUTICO: creare funzione che verifica se la mossa ipotetica fa perdere il pezzo (verifica scacco + mosse "furbe")


/*
 ***** CHANGELOG *****
 */

// Ver 0.1.5a
// - Tactical CheckBoard Redesigned
// - gtk_rc_parse("/etc/joshua.rc") removed (theme independent color managment)
// - AI Algorithm more aggressive (!)
// - Disabled Buttons NOT sensitive
// - Debug checkboard injectable for developers ('adjust' button)
// - Added function to move the king under check
// - Bugfix: history colors were swapped
// - Bugfix: minor bugfixes in gpk_compute_best_moves()
// - Bugfix: signals disabled in libcurl (caused segmentation fault when dns was unreachable) 
// - Bugfix: redraw refreshed only one graphic window 
// - Bugfix: robot tower elevation effect resync 

// Ver 0.1.4a
// - Parallel port accesser to drive steppers + gui monitor (beta test)
// - Message-Server on gipoco.com + player list downloaded by the server (new thread)
// - Coments and GUI Translation from Italian to English 
// - Gui tuning (stepper bits renumeration, controls restyle, chat GUI, window not resizeable, autoreset don't clear history)
// - PANIC Button implementation (Game Pause)
// - Basic players match timers (total and for each player)
// - Bugfix: closing GUI message thread don't crash (perfect exit)
// - Bugfix: history shows moves in alternate colors without warnings in terminal
// - Bugfix: convert sprintf code in snprintf + parser updated + strlen wrapper
// - Bugfix: pawns jumped chips the first time they moved
// - Bugfix: old buggy reset after autoplay now works (asyncronows & threaded)
// - BugFix: state machine debug, players swapped in autoplay
// - BugFix: no more need to run joshua and reset (gpk_game_reset() in main.c without errors)

// Ver 0.1.3a
// - Big GUI restyle and new functions added
// - Removed old camera view
// - gtk_rc file pointed in /etc
// - Initial setup of the robot BETA (gui buttons not funtionals)
// - Minor bugfixes, types, estetics, removed old commented code
// - New message thread (show and blink) 
// - Bugfix: chips tanken strange behaviour in depot


/*
 ***** INCLUDE HEADERS *****
 */

#include <sys/io.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <libgnomeui-2.0/gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>


/*
 ***** DEFINE IO PORTS *****
 */

#define base_addr1 0x378           /* lpt1 port base address */
#define base_addr2 0x378           /* lpt2 port base address */
#define base_addr3 0x378           /* lpt3 port base address */
#define base_addr4 0x378           /* lpt4 port base address */


/*
 ***** DEFINE DELAYS *****
 */
#define DELAY_CURL_LOCK                      24988
#define DELAY_PRE_COMPUTE                    12345
#define DELAY_PRE_COMPUTE2                   12345
#define DELAY_SHOW_OTHER_MOVE               800000

// SLOW TIMING
#define DELAY_THREAD_WAIT_MOVE               23256
#define DELAY_THREAD_WAIT_MOVE2              23256
#define DELAY_THREAD_WAIT_MOVE3              23256
#define DELAY_THREAD_BETWEEN_MOVE            63231
#define DELAY_THREAD_BETWEEN_PLAYERS        131313
#define DELAY_THREAD2_BETWEEN_STATES         13777
#define DELAY_THREAD2_BETWEEN_STATES2        88888
#define DELAY_THREAD2_BETWEEN_STATES_SLOW   500000

/*
// FAST TIMING
#define DELAY_THREAD_WAIT_MOVE                 236
#define DELAY_THREAD_WAIT_MOVE2                236
#define DELAY_THREAD_WAIT_MOVE3                236
#define DELAY_THREAD_BETWEEN_MOVE              631
#define DELAY_THREAD_BETWEEN_PLAYERS          1313
#define DELAY_THREAD2_BETWEEN_STATES           177
#define DELAY_THREAD2_BETWEEN_STATES2          888
#define DELAY_THREAD2_BETWEEN_STATES_SLOW     5000
*/

#define DELAY_THREAD3_BETWEEN_HILIGHT_SLOW  975000
#define DELAY_THREAD3_BETWEEN_HILIGHT_FAST   80000
#define DELAY_THREAD4_NETWORK_WAIT         2998377


/*
 ***** DEFINE COLORS *****
 */

#define BLACK 0
#define RED 1
#define GREEN 2
#define BLUE 3
#define YELLOW 4
#define ORANGE 5
#define GOLD 6
#define SEA_GREEN 7
#define AQUAMARINE 8
#define NAVY_BLUE 9
#define LIGHT_TAN 10
#define LEMON 11
#define PURPLE 12
#define LIGHT_GREY 13
#define MID_GREY 14
#define MID2_GREY 15
#define DARK_GREY 16
#define RED_2 17
#define NAVY_BLUE_2 18
#define NAVY_BLUE_DARK 19
#define RED_DARK 20
#define WHITE 21


/*
 ***** FUNCTIONS DECLARATIONS *****
 */
void gpk_update_chat(GtkButton *button, gchar *ttt);
void gpk_clear_chat(GtkButton *button);
void gpk_update_history(GtkButton *button, gchar *ttt);
void gpk_clear_history(GtkButton *button);
void gpk_game_reset(GtkButton *button);
void gpk_disable_buttons(GtkButton *button);
void gpk_dump_chessboard(GtkButton *button);
void gpk_dump_valid_moves(void);
void gpk_dump_best_moves(void);

void gpk_update_chessboard(GtkButton *button);
void gpk_update_stat_num(GtkButton *button, int num, int val);
void gpk_update_stat_str(GtkButton *button, int num, char *str);
void gpk_update_stat_net_lag(GtkButton *button, int num);
void gpk_update_stat_net_traf(GtkButton *button, int num);
void gpk_update_stats(GtkButton *button);

void gpk_actor_game(int x, int y, GtkWidget *button);
void gpk_set_checkboard(GtkButton *button, int x, int y, gchar val, int colore);
void gpk_update_num_chips(int who, gchar type);
void gpk_check_gameover(GtkButton *button);
void gpk_backup_colors(void);
void gpk_alternate_colors(void);
void gpk_recovery_colors(void);
void gpk_automata(void);
void gpk_do_arrocco(int who);
int  gpk_find_chips(int actual_player);
int  gpk_check_warning_position(int x, int y);

void gpk_insert_best_move(int x, int y);
int  gpk_compute_best_moves(int x, int y);
void gpk_insert_valid_move(int x, int y);
int  gpk_compute_valid_moves(int x, int y);
int  gpk_check_this_move(int x, int y);

void gpk_outb(GtkWidget *here, int val, int motor);
void gpk_curl_fetch(GtkButton *button, gchar *ttt, int debug);
void gpk_curl_free(int debug);
int  gpk_strlen(char *str);

void gpk_draw_position2(GtkButton *here);
void gpk_draw_position(GtkButton *here);
void gpk_set_color(GtkWidget *here, GdkGC *gc, gint name);
void gpk_clear_community_treeview(GtkButton *button);
void gpk_populate_community_treeview(GtkButton *button);
void gpk_inject_board(void);

void *gpk_thread(void *arg);  // ----- thread autoplay -----
void *gpk_thread2(void *arg); // ----- thread robot-mv -----
void *gpk_thread3(void *arg); // ----- thread messages -----
void *gpk_thread4(void *arg); // ----- thread network -----


/*
 ***** VARIABLES DECLARATIONS *****
 */

int ct;           // Chip taken by the robot (color) 
gchar tt;         // Chip taken by the robot (type)
gchar gt[8][12];  // Chips on strategic checkboard (8x8 chips + aux poiters for castling)
gchar gt1[8][12]; // Chips on real-time checkboard (8x8 chips + aux poiters for castling)
gchar dt[2][16];  // Chips on depot (chips taken by each player)
int gc[8][12];    // Chips colors on strategic checkboard (8x8 chips + aux pointers for castling)
int gc1[8][12];   // Chips colors on real-time checkboard (8x8 chips + aux pointers for castling)
int gc2[8][12];   // chips colors on temporary checkboard (for possible moves)
int gn1[8];       // Chips counter PLAYER 1
int gn2[8];       // Chips counter PLAYER 2
int vittorie[2];  // Win counter
int mangiate[2];  // Chips taken counter

int stato=0;         // Main State Machine
int timer_on=0;      // Start update timers ?
int timer[2];        // Timer for each player
int mossa[2];        // Move temp storage
int num_mosse=0;     // Move Counter
int actual_player=1; // Who is playing now ?
int arrocco_flag[2]; // Castling possible (k e t not moved) ?
int arrocco_started; // Castling started (wait request) ?
int game_paused=0;   // Game paused now ?
int warm_start=0;    // Game needs reset ?
int cold_start=1;    // Game just started ?
int last_game=9;     // Number of players of last game played ('9' x reset state)

int best_move[28][2];      // All capturing moves of actual player
int valid_move[28][2];     // All moves of actual player
int valid_chip[28][2];     // All chips of actual player 
int best_move_cnt=0;       // Number of capturing moves from actual position
int valid_move_cnt=0;      // Number of validated moves from actual position
int valid_chip_cnt=0;      // Number of chips on the checkboard 

int stato_r=0;         // Robot state machine
int translate_bit[24]; // Bit-a-bit translation of axis state
int x1,y1,x2,y2;       // Robot start==>stop coordinates (on stepper space coord.)
int xx,yy,zz;          // Robot hand position in 3 dim. (on stepper space coord.)
int xo=9;              // Offset position top-left checkboard (x coord.)
int yo=7;              // Offset position top-left checkboard (y coord.)
int zo=7;              // Offset to reach chips from the z=0 plane (from up)
int xd[2];             // First free position of the chips depot (x coord.)
int yd[2];             // First free position of the chips depot (y coord.)

int tag_flag=0;                // History color tags created ?
int lpt_perm_taken=0;          // I/O Permission taken ?
int message_hilight=0;         // Messages blinking ?
int message_blink_threshold=0; // Fast blink countdown
gchar message_string[32];      // Blinking message

int thread_started=0;  // Main Thread started ?
int thread2_started=0; // Bot Thread started ?
int thread3_started=0; // Msg Thread started ?
int thread4_started=0; // Net Thread started ?
pthread_t thd1;        // PThread Structures for AUTOPLAY
pthread_t thd2;        // PThread Structures for GUI DRAW
pthread_t thd3;        // PThread Structures for MESSAGES
pthread_t thd4;        // PThread Structures for NETWORK

int need_refresh_list=0; // Reload needed for network player's list ?
int network_lag=0;       // Network access time in 1/10 sec units
int network_traf=0;      // Network traffic in bytes (only download)

static GdkPixmap *pixmap=NULL; // Robot preview draw-area
static GtkTextTag *tag;        // History red tag
static GtkTextTag *tag2;       // History blue tag

int gpk_curl_lock=0;   // Curl thread_safer lock
CURL *curl_handle;     // Curl handler
struct MemoryStruct {  // Curl buffer type
	char *memory;
	size_t size;
};
struct MemoryStruct chunk; // Curl buffer

enum {		       // Community View Columns
  COL_NAME = 0,
  COL_AGE,
  NUM_COLS
} ;

// Tactical Checkboard Colors
GdkColor col_lgrey;
GdkColor col_red;
GdkColor col_black;
GdkColor col_yellow;
GdkColor col_white;
GdkColor col_purple;
GdkColor col_green;
GdkColor col_orange;
	

/*
 ***** CUSTOM FUNCTIONS *****
 */


/* ***** ASSIGN COLOR TO GRAPHIC CONTEST (for drawareas) ***** */
void gpk_set_color(GtkWidget *here, GdkGC *gc2, gint name) {

	GdkColor colour;
	
	switch (name) {
	case BLACK:
		colour.red = 0;
		colour.green = 0;
		colour.blue = 0;
	break;
	case RED:
		colour.red = 65535;
		colour.green = 0;
		colour.blue = 0;
	break;
	case GREEN:
		colour.red = 0;
		colour.green = 65535;
		colour.blue = 0;
	break;
	case BLUE:
		colour.red = 0;
		colour.green = 0;
		colour.blue = 65535;
	break;
	case YELLOW:
		colour.red = 65535;
		colour.green = 65535;
		colour.blue = 0;
	break;
	case ORANGE:
	case GOLD:
		colour.red = 65535;
		colour.green = 50000;
		colour.blue = 10000;
	break;
	case SEA_GREEN:
		colour.red = 11150;
		colour.green = 55705;
		colour.blue = 40632;
	break;
	case AQUAMARINE:
		colour.red = 10000;
		colour.green = 65535;
		colour.blue = 50000;
	break;
	case NAVY_BLUE:
		colour.red = 0;
		colour.green = 32000;
		colour.blue = 65535;
	break;
	case LIGHT_TAN:
		colour.red = 65535;
		colour.green = 65535;
		colour.blue = 53739;
	break;
	case LEMON:
		colour.red = 64890;
		colour.green = 63569;
		colour.blue = 29491;
	break;
	case PURPLE:
		colour.red = 64000;
		colour.green = 30000;
		colour.blue = 64000;
	break;
	case LIGHT_GREY:
		colour.red = 58000;
		colour.green = 58000;
		colour.blue = 58000;
	break;
	case MID_GREY:
		colour.red = 40000;
		colour.green = 40000;
		colour.blue = 40000;
	break;
	case MID2_GREY:
		colour.red = 48000;
		colour.green = 48000;
		colour.blue = 48000;
	break;
	case DARK_GREY:
		colour.red = 16000;
		colour.green = 16000;
		colour.blue = 16000;
	break;
	case RED_2:
		colour.red = 65535;
		colour.green = 32000;
		colour.blue = 32000;
	break;
	case NAVY_BLUE_2:
		colour.red = 22000;
		colour.green = 48000;
		colour.blue = 65535;
	break;
	case NAVY_BLUE_DARK:
		colour.red = 0;
		colour.green = 16000;
		colour.blue = 32000;
	break;
	case RED_DARK:
		colour.red = 48000;
		colour.green = 0;
		colour.blue = 0;
	break;
	case WHITE:
	default:
		colour.red = 65535;
		colour.green = 65535;
		colour.blue = 65535;
	break;
	}

	if (!gdk_color_alloc(gtk_widget_get_colormap(here), &colour)) g_print("Warning: colour assignment failed.\n");
	gdk_gc_set_foreground(gc2, &colour);
}


/* ***** Secure StrLen Wrapper ***** */
int gpk_strlen(char *str) {
	if (str!=NULL) {
		return strlen(str);
	} else {
		return 0;
	}
}


/* ***** Secure ReAlloc Wrapper ***** */
void *myrealloc(void *ptr, size_t size) {
	if (ptr) {
		return realloc(ptr, size);
	} else {
		return malloc(size);
	}
}


/* ***** Curl Memory Writer ***** */
size_t WriteMemoryCallback(void *ptr, size_t size, size_t nmemb, void *data) {
	
	size_t realsize=size *nmemb;
	struct MemoryStruct *mem=(struct MemoryStruct *)data;
	
	mem->memory=(char *)myrealloc(mem->memory, mem->size+realsize+1);
	if (mem->memory) {
		memcpy(&(mem->memory[mem->size]), ptr, realsize);
		mem->size+=realsize;
		mem->memory[mem->size]=0;
	}
	return realsize;
}


/* ***** Clear network player's list ***** */
void gpk_clear_community_treeview(GtkButton *button) {

	GtkTreeModel *model;
	GtkWidget *treeview=lookup_widget(GTK_WIDGET(button), "treeview1");

	model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
	gtk_list_store_clear(model);
}


/* ***** Fetch xml from messageserver in http with curl and populate player's list ***** */
void gpk_populate_community_treeview(GtkButton *button) {

	gchar msg[64101];    // + 101 x debug overhead
	gchar temp[64001];   // + 1 x \n & string terminator
	gchar temp2[64001];  // + 1 x \n & string terminator
	gchar nick[16];      // Must be 12
	gchar stat[8];       // Must be 4
	GtkTreeModel *model;
	GtkTreeIter new_row;
	GtkWidget *treeview=lookup_widget(GTK_WIDGET(button), "treeview1");
	int i,n;
	int cnt=0;

	
	msg[64100]=0;
	temp[64000]=0;
	temp2[64000]=0;
	gpk_curl_fetch(button, "http://joshua.gipoco.com/msgserv.php?cmd=list", 1);
	
	if (chunk.size==0) {
		snprintf(temp, 64000, "VOID !!\n");
	} else if (chunk.size>=64000) {
		snprintf(temp, 64000, "OVERFLOW !!\n");
	} else {
		snprintf(temp, chunk.size+1, "%s\n", chunk.memory);
	}
	
	temp[chunk.size]=0;
	for (i=0;i<64000;i++) { temp2[i]=0; }
	
	if (temp!=NULL) {
		n=gpk_strlen(temp);
		while (n>12) {
			for (i=0;i<16;i++) { nick[i]=0; }
			for (i=0;i<8;i++) { stat[i]=0; }
			snprintf(msg, 64100, "-while- (%d) '%s'\n", n, temp);
			g_print (msg);
			for (i=0;i<64000;i++) { temp2[i]=0; }
			for (i=0;i<(n-4);i++) {                        // Drop '252' at the beginnig of the message
				temp2[i]=temp[i+4];
			}
			temp2[i+1]=0;
			for (i=0;i<4;i++) {                            // Get 4 chars of player state
				stat[i]=temp2[i];
			}
			for (i=0;i<64000;i++) { temp[i]=0; }
			for (i=0;i<(gpk_strlen(temp2)-5);i++) {            // Reset temp vars to new offset (jump over the space)
				temp[i]=temp2[i+5];
			}
			temp[i+1]=0;
			for (i=0;((temp[i]!='<')&&(i<15));i++) {       // Get the link of actual pointer to '<' of '<br>' (field separator)
				nick[i]=temp[i];
				cnt=i;
			}
			for (i=0;i<64000;i++) { temp2[i]=0; }
			for (i=0;i<(gpk_strlen(temp)-(cnt+5));i++) {       // Reset temp vars to new offset (jump over the space)
				temp2[i]=temp[i+cnt+5];
			}
			temp2[i+1]=0;
			for (i=0;i<64000;i++) { temp[i]=0; }
			for (i=0;i<gpk_strlen(temp2);i++) {                // Reset temp vars to new offset (jump over the space)
				temp[i]=temp2[i];
			}
			temp[i+1]=0;
			model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
			gtk_list_store_append(GTK_LIST_STORE(model), &new_row);
			gtk_list_store_set(GTK_LIST_STORE(model), &new_row, COL_NAME, nick, COL_AGE, stat, -1);
			n=gpk_strlen(temp);
		}
	}
	gpk_curl_free(1);
	if (temp!=NULL) { 
		g_print(temp);
	}
}


/* ***** OUTPUT a VALUE on a MOTOR AXIS (OutB Wrapper) ***** */
void gpk_outb(GtkWidget *here, int val, int motor) {

	GtkToggleButton *widget_a1=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton1");
	GtkToggleButton *widget_a2=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton2");
	GtkToggleButton *widget_a3=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton3");
	GtkToggleButton *widget_a4=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton4");

	GtkToggleButton *widget_b1=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton5");
	GtkToggleButton *widget_b2=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton6");
	GtkToggleButton *widget_b3=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton7");
	GtkToggleButton *widget_b4=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton8");

	GtkToggleButton *widget_c1=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton9");
	GtkToggleButton *widget_c2=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton10");
	GtkToggleButton *widget_c3=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton11");
	GtkToggleButton *widget_c4=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton12");

	GtkToggleButton *widget_d1=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton13");
	GtkToggleButton *widget_d2=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton14");
	GtkToggleButton *widget_d3=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton15");
	GtkToggleButton *widget_d4=(GtkToggleButton *)lookup_widget(GTK_WIDGET(here), "checkbutton16");

	if (motor==0) {
		if (lpt_perm_taken) outb(val, base_addr1);
		gtk_toggle_button_set_active(widget_a1, (((val&1)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_a2, (((val&2)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_a3, (((val&4)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_a4, (((val&8)>0)?TRUE:FALSE));
	}
	if (motor==1) {
		//if (lpt_perm_taken) outb(val, base_addr2);
		gtk_toggle_button_set_active(widget_b1, (((val&1)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_b2, (((val&2)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_b3, (((val&4)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_b4, (((val&8)>0)?TRUE:FALSE));
	}
	if (motor==2) {
		//if (lpt_perm_taken) outb(val, base_addr3);
		gtk_toggle_button_set_active(widget_c1, (((val&1)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_c2, (((val&2)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_c3, (((val&4)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_c4, (((val&8)>0)?TRUE:FALSE));
	}
	if (motor==3) {
		//if (lpt_perm_taken) outb(val, base_addr4);
		gtk_toggle_button_set_active(widget_d1, (((val&1)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_d2, (((val&2)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_d3, (((val&4)>0)?TRUE:FALSE));
		gtk_toggle_button_set_active(widget_d4, (((val&8)>0)?TRUE:FALSE));
	}
}


/* ***** DRAW BACKGROUND AND CHECKBOARD IN DRAWING-AREA 2 ***** */
void gpk_draw_position2(GtkButton *here) {

	// ---- local vars -----
	int i,j;
	GtkWidget *widget=lookup_widget(GTK_WIDGET((GtkWidget *)here), "drawingarea2");
	GdkGC *gc0=widget->style->black_gc;

	// ----- MALLOC FRAMEBUFFER -----
	if (pixmap) gdk_pixmap_unref(pixmap);
	pixmap = gdk_pixmap_new(widget->window, widget->allocation.width, widget->allocation.height, -1);
	
	// ----- CLEAR BACKBGROUND + CHECKBOARD BACKGROUND -----
	gpk_set_color(widget, gc0, WHITE);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
	gpk_set_color(widget, gc0, MID2_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 100, 150, 80, 10);
	gpk_set_color(widget, gc0, MID_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 25, 160, 220, 5);
	gpk_set_color(widget, gc0, MID_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 35, 165, 20, 70);
	gpk_set_color(widget, gc0, MID_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 210, 165, 20, 70);

	// ----- DRAW CHECKBOARD -----
	for (i=101;i<180;i+=20) {
		gpk_set_color(widget, gc0, RED_DARK);
		gdk_draw_rectangle(pixmap, gc0, TRUE, i,    151, 8, 3);
		gpk_set_color(widget, gc0, WHITE);
		gdk_draw_rectangle(pixmap, gc0, TRUE, i+10, 151, 8, 3);
	}

	// ----- DRAW X e Y ROBOT AXIS -----
	gpk_set_color(widget, gc0, BLACK);
	gdk_draw_line(pixmap, gc0, 15+xx*10, 90+zz*4, 15+xx*10, 120+zz*4);
	gdk_draw_line(pixmap, gc0, 10, 115, 253, 115);
	gpk_set_color(widget, gc0, BLACK);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 14+xx*10, 119+zz*4, 3, 3);
	gpk_set_color(widget, gc0, ORANGE);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 13+xx*10-(zz/2), 119+zz*4, zz*2, zz);

	// ----- UPDATE FRAMEBUFFER -----
	GdkRectangle update_rect;
	update_rect.x = 8;
	update_rect.y = 3;
	update_rect.width = 243;
	update_rect.height = 3;
	gtk_widget_draw (widget, &update_rect);
	gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], pixmap,
			8, 5, 5, 0, widget->allocation.width, widget->allocation.height);
}


/* ***** DRAW BACKGROUND AND CHECKBOARD IN DRAWING-AREA ***** */
void gpk_draw_position(GtkButton *here) {

	// ---- local vars -----
	int i,j;
	int chip_width;
	GtkWidget *widget=lookup_widget(GTK_WIDGET((GtkWidget *)here), "drawingarea1");
	GdkGC *gc0=widget->style->black_gc;

	// ----- MALLOC FRAMEBUFFER -----
	if (pixmap) gdk_pixmap_unref(pixmap);
	pixmap = gdk_pixmap_new(widget->window, widget->allocation.width, widget->allocation.height, -1);
	
	// ----- CLEAR BACKBGROUND + CHECKBOARD BACKGROUND + DEPOTS BACKGROUND -----
	gpk_set_color(widget, gc0, WHITE);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 0, 0, widget->allocation.width, widget->allocation.height);
	gpk_set_color(widget, gc0, MID2_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 25, 25, 220, 200);
	gpk_set_color(widget, gc0, LIGHT_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 100, 80, 80, 80);
	gpk_set_color(widget, gc0, LIGHT_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 100, 40, 80, 20);
	gpk_set_color(widget, gc0, LIGHT_GREY);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 100, 180, 80, 20);

	// ----- DRAW CHECKBOARD -----
	gpk_set_color(widget, gc0, BLACK);
	for (j=0;j<4;j++) {
		for (i=100;i<180;i+=20) {
			gdk_draw_rectangle(pixmap, gc0, TRUE, i,    (80+(j*20)), 10, 10);
			gdk_draw_rectangle(pixmap, gc0, TRUE, i+10, (90+(j*20)), 10, 10);
		}
	}

	// ----- DRAW CHIP'S DEPOTS -----
	gpk_set_color(widget, gc0, NAVY_BLUE_DARK);
	for (i=100;i<180;i+=20) {
		gdk_draw_rectangle(pixmap, gc0, TRUE, i,    40, 10, 10);
		gdk_draw_rectangle(pixmap, gc0, TRUE, i+10, 50, 10, 10);
	}
	gpk_set_color(widget, gc0, RED_DARK);
	for (i=100;i<180;i+=20) {
		gdk_draw_rectangle(pixmap, gc0, TRUE, i,    180, 10, 10);
		gdk_draw_rectangle(pixmap, gc0, TRUE, i+10, 190, 10, 10);
	}

	// ----- DRAW CHIPS IN DEPOTS -----
	gpk_set_color(widget, gc0, BLACK);
	for (i=0;i<16;i++) {
		if (dt[0][i]!=' ') {
			chip_width=3;
			if (i>7) {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+(i-8)*10, (55-chip_width), chip_width*2, chip_width*2);
			} else {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (45-chip_width), chip_width*2, chip_width*2);
			}
			/*
			chip_width=3;
			if (dt[0][i]=='K') chip_width=5;
			if (dt[0][i]=='Q') chip_width=5;
			if (dt[0][i]=='p') chip_width=2;
			gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (45-chip_width), chip_width*2, chip_width*2);
			if (dt[0][i]=='K') chip_width=3;
			if (dt[0][i]=='Q') chip_width=2;
			if ((dt[0][i]=='K')||(dt[0][i]=='Q')) {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (85-chip_width)+(j*10), chip_width*2, chip_width*2);
			}
			*/
		}
		if (dt[1][i]!=' ') {
			chip_width=3;
			if (i>7) {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+(i-8)*10, (195-chip_width), chip_width*2, chip_width*2);
			} else {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (185-chip_width), chip_width*2, chip_width*2);
			}
			/*
			chip_width=3;
			if (dt[1][i]=='K') chip_width=5;
			if (dt[1][i]=='Q') chip_width=5;
			if (dt[1][i]=='p') chip_width=2;
			gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (185-chip_width), chip_width*2, chip_width*2);
			if (dt[1][i]=='K') chip_width=3;
			if (dt[1][i]=='Q') chip_width=2;
			if (dt[1][i]=='K')||(dt[1][i]=='Q')) {
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (85-chip_width)+(j*10), chip_width*2, chip_width*2);
			}
			*/
		}
	}
	
	// ----- DRAW CHIPS -----
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			if (gt1[i][j]!=' ') {
				chip_width=3;
				if (gc1[i][j]==2) {
					gpk_set_color(widget, gc0, RED);
				} else {
					gpk_set_color(widget, gc0, NAVY_BLUE);
				}
				if (gt1[i][j]=='K') chip_width=5;
				if (gt1[i][j]=='Q') chip_width=5;
				if (gt1[i][j]=='p') chip_width=2;
				gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (85-chip_width)+(j*10), chip_width*2, chip_width*2);

				if (gc1[i][j]==2) {
					gpk_set_color(widget, gc0, RED_2);
				} else {
					gpk_set_color(widget, gc0, NAVY_BLUE_2);
				}
				if (gt1[i][j]=='K') chip_width=3;
				if (gt1[i][j]=='Q') chip_width=2;
				if ((gt1[i][j]=='K')||(gt1[i][j]=='Q')) {
					gdk_draw_rectangle(pixmap, gc0, TRUE, (105-chip_width)+i*10, (85-chip_width)+(j*10),
                                                           chip_width*2, chip_width*2);
				}
			}
		}
	}
	//gdk_draw_line(pixmap, widget->style->black_gc, 15+xx, 8, 15+xx, 245);
	//gdk_draw_line(pixmap, widget->style->black_gc, 10, 15+yy, 253, 15+yy);
	//gdk_draw_line(pixmap, widget->style->black_gc, 100+xx, 8, 100+xx, 245);
	//gdk_draw_line(pixmap, widget->style->black_gc, 10, 80+yy, 253, 80+yy);

	// ----- DRAW X e Y ROBOT AXIS -----
	gpk_set_color(widget, gc0, BLACK);
	gdk_draw_line(pixmap, gc0, 15+xx*10, 8, 15+xx*10, 245);
	gdk_draw_line(pixmap, gc0, 10, 15+yy*10, 253, 15+yy*10);

	// ----- DRAW ELEVATION EFFECT ON Z AXIS -----
	gpk_set_color(widget, gc0, YELLOW);
	gdk_draw_rectangle(pixmap, gc0, TRUE, 15+xx*10-zz, 15+yy*10-zz, zz*2, zz*2);
	
	// ----- DRAW TAKEN CHIP -----
	if (ct>0) {
		if (ct==1) gpk_set_color(widget, gc0, NAVY_BLUE);
		if (ct==2) gpk_set_color(widget, gc0, RED);
		gdk_draw_rectangle(pixmap, gc0, TRUE, 13+xx*10, 13+yy*10, 5, 5);
	}

	// ----- UPDATE FRAMEBUFFER -----
	GdkRectangle update_rect;
	update_rect.x = 8;
	update_rect.y = 3;
	update_rect.width = 243;
	update_rect.height = 3;
	gtk_widget_draw (widget, &update_rect);
	gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], pixmap,
			8, 5, 5, 0, widget->allocation.width, widget->allocation.height);
}


/* ***** UPDATE 1 NUMERIC STAT ***** */
void gpk_update_stat_num(GtkButton *button, int num, int val) {
	
	gchar temp[8];
	gchar target[16];
	
	temp[7]=0;
	target[15]=0;
	snprintf(temp, 7, "%d", val);
	snprintf(target, 15, "entry%d", num);
	GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), target);
	gtk_entry_set_text(GTK_ENTRY(gwidget), temp);
}


/* ***** UPDATE 1 TEXTUAL STAT ***** */
void gpk_update_stat_str(GtkButton *button, int num, char *str) {
	
	gchar target[16];
	
	target[15]=0;
	snprintf(target, 15, "entry%d", num);
	GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), target);
	gtk_entry_set_text(GTK_ENTRY(gwidget), str);
}


/* ***** UPDATE STAT NETWORK LAG ***** */
void gpk_update_stat_net_lag(GtkButton *button, int num) {
	
	gchar temp[16];
	
	temp[15]=0;
	snprintf(temp, 15, "%d sec", num);
	GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), "entry101");
	gtk_entry_set_text(GTK_ENTRY(gwidget), temp);
}


/* ***** UPDATE STAT NETWORK TRAFFIC ***** */
void gpk_update_stat_net_traf(GtkButton *button, int num) {
	
	gchar temp[16];
	
	temp[15]=0;
	if (num<1000) {
		snprintf(temp, 15, "%d Bytes", num);
	} else if (num<1000000) {
		snprintf(temp, 15, "%4.2f KBytes", (float)num/(float)1000);
	} else if (num<1000000000) {
		snprintf(temp, 15, "%4.2f MBytes", (float)num/(float)1000000);
	} else {
		snprintf(temp, 15, "%4.2f GBytes", (float)num/(float)1000000000);
	}
	GtkWidget* gwidget= lookup_widget(GTK_WIDGET(button), "entry25");
	gtk_entry_set_text(GTK_ENTRY(gwidget), temp);
}


/* ***** UPDATE STATS ***** */
void gpk_update_stats(GtkButton *button) {
	gpk_update_stat_num(button, 13, gn1[1]);
	gpk_update_stat_num(button, 14, gn1[2]);
	gpk_update_stat_num(button, 15, gn1[3]);
	gpk_update_stat_num(button, 16, gn1[4]);
	gpk_update_stat_num(button, 17, gn1[5]);

	gpk_update_stat_num(button, 18, gn2[1]);
	gpk_update_stat_num(button, 19, gn2[2]);
	gpk_update_stat_num(button, 20, gn2[3]);
	gpk_update_stat_num(button, 21, gn2[4]);
	gpk_update_stat_num(button, 22, gn2[5]);

	gpk_update_stat_num(button, 1, vittorie[0]);
	gpk_update_stat_num(button, 3, vittorie[1]);
	gpk_update_stat_num(button, 11, stato);
	gpk_update_stat_str(button, 7, ((actual_player==1)?"Black":"Red"));
	gpk_update_stat_num(button, 10, num_mosse);
}


/* ***** CHIP-COUNTER ***** */
void gpk_update_num_chips(int who, gchar type) {
	if (who==2) {
		if (type=='K') gn2[0]--;
		if (type=='Q') gn2[1]--;
		if (type=='B') gn2[2]--;
		if (type=='H') gn2[3]--;
		if (type=='T') gn2[4]--;
		if (type=='p') gn2[5]--;
	} else {
		if (type=='K') gn1[0]--;
		if (type=='Q') gn1[1]--;
		if (type=='B') gn1[2]--;
		if (type=='H') gn1[3]--;
		if (type=='T') gn1[4]--;
		if (type=='p') gn1[5]--;
	}
}


/* ***** CHECKMATE ? ***** */
void gpk_check_gameover(GtkButton *button) {
	if ((gn1[0]==0)||(gn2[0]==0)) {
		g_print("\n\nCHECKMATE !!\n\n");
		vittorie[((gn1[0]==0)?0:1)]++;
		stato=0;
		warm_start=1;
		g_print("\nWarm start initiated....\n");
	}
}


/* ***** PAWNS PROMOTION ***** */
void gpk_automata(void) {

	int i;

	for (i=0;i<8;i++) { // ----- RED PAWN PROMOTION -----
		if ((gt[i][0]=='p')&&(gc[i][0]==2)) {
			gt[i][0]='Q';
		}
	}
	for (i=0;i<8;i++) { // ----- BLACK PAWN PROMOTION -----
		if ((gt[i][7]=='p')&&(gc[i][7]==1)) {
			gt[i][7]='Q';
		}
	}
}


/* ***** EXECUTE CASTLING ***** */
void gpk_do_arrocco(int who) {

	if (who==2) { // ----- RED CASTLING -----
		//gt[6][7]=gt[4][7];
		//gt[5][7]=gt[7][7];
		gt[4][7]=' ';
		gt[5][7]='T';
		gt[6][7]='K';
		gt[7][7]=' ';
		gc[4][7]=0;
		gc[5][7]=2;
		gc[6][7]=2;
		gc[7][7]=0;
	}
	if (who==1) { // ----- BLACK CASTLING -----
		//gt[6][0]=gt[4][0];
		//gt[5][0]=gt[7][0];
		gt[4][0]=' ';
		gt[5][0]='T';
		gt[6][0]='K';
		gt[7][0]=' ';
		gc[4][0]=0;
		gc[5][0]=1;
		gc[6][0]=1;
		gc[7][0]=0;
	}
}


/* ***** PUT ONE NEW MOVE IN THE MOVES ARRAY ***** */
void gpk_insert_valid_move(int x, int y) {
	valid_move[valid_move_cnt][0]=x;
	valid_move[valid_move_cnt][1]=y;
	valid_move_cnt++;
}


/* ***** PUT ONE GOOD CAPTURE MOVE IN THE MOVES ARRAY ***** */
void gpk_insert_best_move(int x, int y) {
	best_move[best_move_cnt][0]=x;
	best_move[best_move_cnt][1]=y;
	best_move_cnt++;
}

/* ***** CHECK IF A CHIP WILL BE CAPTURED ***** */
int gpk_check_warning_position(int x, int y) {

	int i,j,k;
	int his_color=((gc[x][y]==1)?2:1);
	int found=0;
	gchar temp[64];


	// For each opponent chip...
	temp[63]=0;
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			if (gc[i][j]==his_color) {
				
				// ...look if he can capture
				gpk_compute_best_moves(i,j);
				if (best_move_cnt>0) {
					for (k=0;k<best_move_cnt;k++) {
						if ((best_move[k][0]==x)&&(best_move[k][1]==y)) {
							found=1;
							snprintf(temp, 63, "\n--- CHECK ---\n\n");
							g_print(temp);
						}
					}
				}
			}
		}
	}
	return found;
}


/* ***** POPULATE CHIPS POSITIONS ARRAY ***** */
int gpk_find_chips(int actual_player) {

	int i,j,n,cnt;
	int warning=0;
	gchar temp[64];
	
	// INIT
	temp[63]=0;
	cnt=0;
	
	// Mush move king ?
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			if ((gt[i][j]=='K')&&(gc[i][j]==actual_player)) {
				if (gpk_check_warning_position(i,j)) {  
					valid_chip[0][0]=i;
					valid_chip[0][1]=j;
					cnt=1;
					warning=1;
				}
			}
		}
	}
	

	// Record all my chips
	if (!warning) {
		for (i=0;i<8;i++) {
			for (j=0;j<8;j++) {
				if ((gt[i][j]!=' ')&&(gc[i][j]==actual_player)) {
					valid_chip[cnt][0]=i;
					valid_chip[cnt][1]=j;
					cnt++;
				}
			}
		}

		// Record the first capture (if any)
		for (i=0;i<cnt;i++) {
			n=gpk_compute_best_moves(valid_chip[i][0], valid_chip[i][1]);
			//snprintf(temp, 63, "--- SUB-SEARCHING: (%d,%d) %d good\n", valid_chip[i][0], valid_chip[i][1], n);
			//g_print(temp);
			if (n>0) {
				valid_chip[0][0]=valid_chip[i][0];
				valid_chip[0][1]=valid_chip[i][1];
				return 1;
			}
		}
	}
	return cnt;
}


/* ***** DUMP MOVES ARRAY ***** */
void gpk_dump_valid_moves(void) {

	int i;
	gchar temp[32];

	temp[31]=0;
	snprintf(temp, 31, "Dump mosse valide: %d\n", valid_move_cnt);
	g_print(temp);
	for (i=0;i<valid_move_cnt;i++) {
		snprintf(temp, 31, "[%d]-[%d]\n", valid_move[i][0], valid_move[i][1]);
		g_print(temp);
	}
	g_print ("\n");
}


/* ***** DUMP CAPTURING MOVES ARRAY ***** */
void gpk_dump_best_moves(void) {

	int i;
	gchar temp[32];

	temp[31]=0;
	snprintf(temp, 31, "Dump mosse che mangiano: %d\n", best_move_cnt);
	g_print(temp);
	for (i=0;i<best_move_cnt;i++) {
		snprintf(temp, 31, "[%d]-[%d]\n", best_move[i][0], best_move[i][1]);
		g_print(temp);
	}
	g_print ("\n");
}


/* ***** SAVE COLORS IN TEMPORARY MATRIX ***** */
void gpk_backup_colors(void) {

	int i,j;

	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			gc2[i][j]=gc[i][j];
		}
	}
}


/* ***** RECOVER COLORS FROM TEMPORARY MATRIX ***** */
void gpk_recovery_colors(void) {

	int i,j;

	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			gc[i][j]=gc2[i][j];
		}
	}
}


/* ***** SWAP COLOR MATRIX ***** */
void gpk_alternate_colors(void) {

	int i;

	for (i=0;i<valid_move_cnt;i++) {
		if (valid_move[i][1]==10) {        // ----- BLACK CASTLING -----
			gc[4][0]=4;
			gc[5][0]=4;
			gc[6][0]=4;
			gc[7][0]=4;
			arrocco_started=1;
		} else if (valid_move[i][1]==11) { // ----- RED CASTLING -----
			gc[4][7]=4;
			gc[5][7]=4;
			gc[6][7]=4;
			gc[7][7]=4;
			arrocco_started=1;
		} else {                           // ----- NORMAL MOVES -----
			if (gc[valid_move[i][0]][valid_move[i][1]]==0) {
				gc[valid_move[i][0]][valid_move[i][1]]=3; // YELLOW COLOR ON POSSIBLE MOVES
			} else {
				gc[valid_move[i][0]][valid_move[i][1]]=5; // GREEN COLOR ON CAPTURING MOVES
			}
		}
	}
	gc[mossa[0]][mossa[1]]=7; // ORANGE COLOR ON ACTUAL POSITION
}


/* ***** VERIFY IF ONE MOVE IS VALID ***** */
int gpk_check_this_move(int x, int y) {

	int i;
	
	for (i=0;i<28;i++) {
		if ((valid_move[i][0]==x)&&(valid_move[i][1]==y)) {
			return 1;
		}
	}
	return 0;
}


/* ***** CHECKBOARD CHIPS DUMP ***** */
void gpk_dump_chessboard(GtkButton *button) {
	
	int i,j;
	gchar temp[32];
	
	temp[31]=0;
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			//snprintf(temp, 31, "%d-", gt[i][j]);
			snprintf(temp, 31, "%d-", gc[i][j]);
			g_print (temp);
		}
		g_print ("\n");
	}
	g_print ("\n");
	snprintf(temp, 31, "Stato: %d\n", stato);
	g_print (temp);
}


/* ***** CHECKBOARD CLEAR AND REFRESH ***** */
void gpk_update_chessboard(GtkButton *button) {
	
	int i,j;
	gchar temp[30];
	
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			gpk_set_checkboard(button, i, j, gt[i][j], gc[i][j]);
		}
	}
}


/* ***** REMOVE OLD MOVES FROM HISTORY COMBOBOX ***** */
void gpk_clear_history(GtkButton *button) {
	
	GtkTextBuffer *buffer;

	GtkWidget* gwidget= lookup_widget(GTK_WIDGET(button), "textview1");
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(gwidget));
	gtk_text_buffer_set_text (buffer, " \n", -1);
}


/* ***** HISTORY COMBOBOX UPDATER AND COLOR ALTERNATOR ***** */
void gpk_update_history(GtkButton *button, gchar *ttt) {
	
	int i;
	gchar temp[30];
	GtkTextBuffer *buffer;
	GdkColor color;
	GtkTextIter start, end;

	GtkWidget* gwidget= lookup_widget(GTK_WIDGET(button), "textview1");
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(gwidget));
	gtk_text_buffer_get_iter_at_offset (buffer, &start, num_mosse*5);
	gtk_text_buffer_insert (buffer, &start, ttt, -1);
	gtk_text_buffer_get_iter_at_offset (buffer, &start, num_mosse*5);
	gtk_text_buffer_get_iter_at_offset (buffer, &end, (num_mosse+1)*5);
	if ((num_mosse%2)==0) {
		gtk_text_buffer_apply_tag (buffer, tag, &start, &end);
	} else {
		gtk_text_buffer_apply_tag (buffer, tag2, &start, &end);
	}
}


/* ***** CLEAR CHAT COMBOBOX ***** */
void gpk_clear_chat(GtkButton *button) {
	
	GtkTextBuffer *buffer;

	GtkWidget* gwidget= lookup_widget(GTK_WIDGET(button), "textview2");
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(gwidget));
	gtk_text_buffer_set_text (buffer, " \n", -1);
}


/* ***** CHAT COMBOBOX UPDATER ***** */
void gpk_update_chat(GtkButton *button, gchar *ttt) {
	
	int i;
	gchar temp[30];
	GtkTextBuffer *buffer;
	GdkColor color;
	GtkTextIter start, end;

	GtkWidget* gwidget= lookup_widget(GTK_WIDGET(button), "textview2");
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(gwidget));
	gtk_text_buffer_get_iter_at_offset (buffer, &start, num_mosse*5);
	gtk_text_buffer_insert (buffer, &start, ttt, -1);
	gtk_text_buffer_get_iter_at_offset (buffer, &start, num_mosse*5);
	gtk_text_buffer_get_iter_at_offset (buffer, &end, (num_mosse+1)*5);
}


/* ***** INJECT A DEVELOPMENT BOARD IN CHECKBOARD VARS ***** */
void gpk_inject_board(void) {

	int i,j;

	// RESET POSIZIONS AND COLORs
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			gt[i][j]=' ';
			gt1[i][j]=' ';
			gc[i][j]=0;
			gc1[i][j]=0;
		}
	}		
	
	// PUT CHIPS IN MATRIX STARTING POSITIONS
	gt[3][5]='T';
	gt[6][4]='B';
	gt[5][0]='Q';
 	gt[7][2]='K';
	gt1[3][5]='T';
	gt1[6][4]='B';
	gt1[5][0]='Q';
 	gt1[7][2]='K';

	gc[3][5]=1;
	gc[6][4]=1;
	gc[5][0]=1;
 	gc[7][2]=1;
	gc1[3][5]=1;
	gc1[6][4]=1;
	gc1[5][0]=1;
 	gc1[7][2]=1;

	gt[1][5]='T';
	gt[2][4]='B';
	gt[1][0]='Q';
 	gt[3][2]='K';
	gt1[1][5]='T';
	gt1[2][4]='B';
	gt1[1][0]='Q';
 	gt1[3][2]='K';

	gc[1][5]=2;
	gc[2][4]=2;
	gc[1][0]=2;
 	gc[3][2]=2;
	gc1[1][5]=2;
	gc1[2][4]=2;
	gc1[1][0]=2;
 	gc1[3][2]=2;

}


/* ***** GUI REFRESH - THREADS RESET ***** */
void gpk_game_reset(GtkButton *button) {

	GtkTextBuffer *buffer;
	gchar temp[2];
	int val=3;
	int i,j,tmp;

	// Get I/O permissions
	GtkToggleButton *widget_a1=(GtkToggleButton *)lookup_widget(GTK_WIDGET(button), "checkbutton19");
	GtkToggleButton *widget_a2=(GtkToggleButton *)lookup_widget(GTK_WIDGET(button), "checkbutton17");
	if (getuid()!=0) {
		gtk_toggle_button_set_active(widget_a1, FALSE);
		gtk_toggle_button_set_active(widget_a2, FALSE);
		g_print ("Not root.... Lpt I/O Access Disabled !!\n");
	} else {
		gtk_toggle_button_set_active(widget_a1, TRUE);
		gtk_toggle_button_set_active(widget_a2, TRUE);
		if (lpt_perm_taken!=1) {
			if (ioperm(base_addr1,1,1)) fprintf(stderr, "Couldn't get the io-port 0x%x (no root?)\n", base_addr1), exit(1);
			gpk_outb((GtkWidget *)button, 0, 0);
			lpt_perm_taken=1;
		}
	}
	
	// Setup Textarea History e Setup Array (ONLY ONCE)
	if (!tag_flag) {
		GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), "textview1");
		buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(gwidget));
		tag2=gtk_text_buffer_create_tag (buffer, "red_foreground", "foreground", "red", NULL);
		tag=gtk_text_buffer_create_tag (buffer, "blue_foreground", "foreground", "blue", NULL);
		tag_flag++;
		
		tmp=1;
		for (i=0;i<25;i++) {
			translate_bit[i]=tmp;
			tmp*=2;
			if (tmp>8) { tmp=1; }
		}
	}

	// INIT COLORS
	col_lgrey.red   = 60000;
	col_lgrey.green = 60000;
	col_lgrey.blue  = 60000;
	col_red.red   = 65535;
	col_red.green = 0;
	col_red.blue  = 0;
	col_black.red   = 0;
	col_black.green = 0;
	col_black.blue  = 0;
	col_yellow.red   = 65535;
	col_yellow.green = 65535;
	col_yellow.blue  = 0;
	col_white.red   = 65535;
	col_white.green = 65535;
	col_white.blue  = 65535;
	col_purple.red   = 65535;
	col_purple.green = 0;
	col_purple.blue  = 65535;
	col_green.red   = 47000;
	col_green.green = 65535;
	col_green.blue  = 0;
	col_orange.red   = 65535;
	col_orange.green = 32768;
	col_orange.blue  = 0;

	// INIT VARS
	stato=0;
	stato_r==20;
	timer_on=0;
	timer[0]=1;
	timer[1]=1;
	arrocco_flag[0]=1;
	arrocco_flag[1]=1;
	arrocco_started=0;
	actual_player=1;
	num_mosse=0;
	xx=0;
	yy=0;
	zz=0;
	tt=' ';
	ct=0;
	mangiate[0]=0;
	mangiate[1]=0;
	xd[0]=9;
	yd[0]=3;
	xd[1]=9;
	yd[1]=17;

	// CHIP NUMBERS RESET
	gn1[0]=1;
	gn1[1]=1;
	gn1[2]=2;
	gn1[3]=2;
	gn1[4]=2;
	gn1[5]=8;
	gn2[0]=1;
	gn2[1]=1;
	gn2[2]=2;
	gn2[3]=2;
	gn2[4]=2;
	gn2[5]=8;

	// RESET CHIPS TAKEN DEPOSITS
	for (i=0;i<16;i++) {
		dt[0][i]=' ';
		dt[1][i]=' ';
	}

	// RESET POSIZIONS AND COLORs
	for (i=0;i<8;i++) {
		for (j=0;j<8;j++) {
			gt[i][j]=' ';
			gt1[i][j]=' ';
			gc[i][j]=0;
			gc1[i][j]=0;
		}
	}		
	
	// PUT CHIPS IN MATRIX STARTING POSITIONS
	gt[0][0]='T';
	gt[1][0]='H';
	gt[2][0]='B';
	gt[3][0]='Q';
 	gt[4][0]='K';
	gt[5][0]='B';
	gt[6][0]='H';
	gt[7][0]='T';
	for (i=0; i<8; i++) {
		gt[i][1]='p';
		gt[i][6]='p';
	}
	gt[0][7]='T';
	gt[1][7]='H';
	gt[2][7]='B';
	gt[3][7]='Q';
	gt[4][7]='K';
	gt[5][7]='B';
	gt[6][7]='H';
	gt[7][7]='T';

	gt1[0][0]='T';
	gt1[1][0]='H';
	gt1[2][0]='B';
	gt1[3][0]='Q';
 	gt1[4][0]='K';
	gt1[5][0]='B';
	gt1[6][0]='H';
	gt1[7][0]='T';
	for (i=0; i<8; i++) {
		gt1[i][1]='p';
		gt1[i][6]='p';
	}
	gt1[0][7]='T';
	gt1[1][7]='H';
	gt1[2][7]='B';
	gt1[3][7]='Q';
	gt1[4][7]='K';
	gt1[5][7]='B';
	gt1[6][7]='H';
	gt1[7][7]='T';

	// PUT STARTING COLORS IN MATRIX
	for (i=0; i<8; i++) {
		gc[i][0]=1;
		gc[i][1]=1;
		gc[i][6]=2;
		gc[i][7]=2;
		gc1[i][0]=1;
		gc1[i][1]=1;
		gc1[i][6]=2;
		gc1[i][7]=2;
	}

	// DRAW CHECKBOARD AND ROBOT AXIS
	gpk_draw_position(button);
	gpk_draw_position2(button);
	
	// START ROBOT THREAD
	if (thread2_started==0) {
		pthread_create(&thd2, NULL, gpk_thread2, button);
		g_print ("J-Robot started now....\n");
		thread2_started++;
	}

	// START MESSAGE THREAD
	message_blink_threshold=20;
	snprintf(message_string, 31, "Connecting...."); // Prewrite message for the next action
	if (thread3_started==0) {
		pthread_create(&thd3, NULL, gpk_thread3, button);
		g_print ("Message started now....\n");
		thread3_started++;
	}

	// START NETWORK THREAD
	need_refresh_list=1;
	if (thread4_started==0) {
		pthread_create(&thd4, NULL, gpk_thread4, button);
		g_print ("Network started now....\n");
		thread4_started++;
	}

	// UPDATE HISTORY & CHAT
	//gpk_clear_history(button); // moved out to let history there after autoplay and clear only manually
	gpk_clear_chat(button);
}


/* ***** SET DISABLE BUTTONS NOT SENSITIVE ***** */
void gpk_disable_buttons(GtkButton *button) {

	gchar target[32];

	target[31]=0;

	// Disable history buttons
	snprintf(target, 31, "button73");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button74");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button77");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button78");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button81");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button80");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);

	//Disable community buttons
	snprintf(target, 31, "button106");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button105");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button97");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button98");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button99");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);

	// Disable chat buttons
	snprintf(target, 31, "button100");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button101");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button102");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button103");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button104");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);

	// Disable robot setup
	snprintf(target, 31, "button82");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button83");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
	snprintf(target, 31, "button86");
	gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(button), target), 0);
}


/* ***** FIND AND CHANGE COLORS OF VALID MOVES FROM ACTUAL POSITION ***** */
int gpk_compute_valid_moves(int x, int y) {

	int i,j,flag;
	int my_color=((gc[x][y]==1)?1:2);
	int his_color=((gc[x][y]==1)?2:1);

	valid_move_cnt=0;

	if (gc[x][y]==actual_player) { 

	for (i=0;i<28;i++) {
		valid_move[i][0]=0;
		valid_move[i][1]=0;
	}

	if (gt[x][y]=='K') { // ------------------- K I N G ----- R E -----------------------
		
		// --- vertical & orizontal ---
		if ((x<7)&&((gc[x+1][y]==his_color)||(gt[x+1][y]==' '))) gpk_insert_valid_move(x+1, y);
		if ((x>0)&&((gc[x-1][y]==his_color)||(gt[x-1][y]==' '))) gpk_insert_valid_move(x-1, y);
		if ((y>0)&&((gc[x][y-1]==his_color)||(gt[x][y-1]==' '))) gpk_insert_valid_move(x, y-1);
		if ((y<7)&&((gc[x][y+1]==his_color)||(gt[x][y+1]==' '))) gpk_insert_valid_move(x, y+1);

		// --- diagonals ---
		if ((x<7)&&(y<7)&&((gc[x+1][y+1]==his_color)||(gt[x+1][y+1]==' '))) gpk_insert_valid_move(x+1, y+1);
		if ((x>0)&&(y>0)&&((gc[x-1][y-1]==his_color)||(gt[x-1][y-1]==' '))) gpk_insert_valid_move(x-1, y-1);
		if ((x<7)&&(y>0)&&((gc[x+1][y-1]==his_color)||(gt[x+1][y-1]==' '))) gpk_insert_valid_move(x+1, y-1);
		if ((x>0)&&(y<7)&&((gc[x-1][y+1]==his_color)||(gt[x-1][y+1]==' '))) gpk_insert_valid_move(x-1, y+1);

		// --- BLACK castling ---
		if ((arrocco_flag[0])&&(gt[5][0]==' ')&&(gt[6][0]==' ')) gpk_insert_valid_move(6, 10);

		// --- RED castling ---
		if ((arrocco_flag[1])&&(gt[5][7]==' ')&&(gt[6][7]==' ')) gpk_insert_valid_move(6, 11);
	}

	if (gt[x][y]=='H') { // ------------------- K N I G T ----- C A V A L L O -----------------------
		
		if ((x<7)&&(y<6)&&((gc[x+1][y+2]==his_color)||(gt[x+1][y+2]==' '))) gpk_insert_valid_move(x+1, y+2);
		if ((x<6)&&(y<7)&&((gc[x+2][y+1]==his_color)||(gt[x+2][y+1]==' '))) gpk_insert_valid_move(x+2, y+1);
		if ((x>0)&&(y>1)&&((gc[x-1][y-2]==his_color)||(gt[x-1][y-2]==' '))) gpk_insert_valid_move(x-1, y-2);
		if ((x>1)&&(y>0)&&((gc[x-2][y-1]==his_color)||(gt[x-2][y-1]==' '))) gpk_insert_valid_move(x-2, y-1);
		if ((x>0)&&(y<6)&&((gc[x-1][y+2]==his_color)||(gt[x-1][y+2]==' '))) gpk_insert_valid_move(x-1, y+2);
		if ((x<6)&&(y>0)&&((gc[x+2][y-1]==his_color)||(gt[x+2][y-1]==' '))) gpk_insert_valid_move(x+2, y-1);
		if ((x<7)&&(y>1)&&((gc[x+1][y-2]==his_color)||(gt[x+1][y-2]==' '))) gpk_insert_valid_move(x+1, y-2);
		if ((x>1)&&(y<7)&&((gc[x-2][y+1]==his_color)||(gt[x-2][y+1]==' '))) gpk_insert_valid_move(x-2, y+1);
	}

	if (gt[x][y]=='p') { // ------------------- P A W N ----- P E D O N E -----------------------
		
		if (gc[x][y]==1) { // ----- BLACK -----
			if ((y<7)&&(gt[x][y+1]==' '))                 gpk_insert_valid_move(x, y+1);   // move down 
			if ((y==1)&&(gt[x][2]==' ')&&(gt[x][3]==' ')) gpk_insert_valid_move(x, 3);     // the first time can go down of 2 positions
			if ((x<7)&&(y<7)&&(gc[x+1][y+1]==2))          gpk_insert_valid_move(x+1, y+1); // capture down-right
			if ((x>0)&&(y<7)&&(gc[x-1][y+1]==2))          gpk_insert_valid_move(x-1, y+1); // capture down-left
		}
		if (gc[x][y]==2) { // ----- RED -----
			if ((y>0)&&(gt[x][y-1]==' '))                 gpk_insert_valid_move(x, y-1);   // move up
			if ((y==6)&&(gt[x][5]==' ')&&(gt[x][4]==' ')) gpk_insert_valid_move(x, 4);     // the first time can go up of 2 positions
			if ((x<7)&&(y>0)&&(gc[x+1][y-1]==1))          gpk_insert_valid_move(x+1, y-1); // capture up-right
			if ((x>0)&&(y>0)&&(gc[x-1][y-1]==1))          gpk_insert_valid_move(x-1, y-1); // capture up-left
		}
	}

	if ((gt[x][y]=='T')||(gt[x][y]=='Q')) { // -------------- ROOK + QUEEN ----- TORRE + REGINA -----------------

		// -- going down --
		flag=0; i=y+1;
		while ((flag==0)&&(i<8)) {
			if (gt[x][i]==' ') gpk_insert_valid_move(x, i);
			if (gt[x][i]!=' ') {
				if (gc[x][i]==his_color) gpk_insert_valid_move(x, i);
				flag++;
			}
			i++;
		}

		// -- going up --
		flag=0; i=y-1;
		while ((flag==0)&&(i>=0)) {
			if (gt[x][i]==' ') gpk_insert_valid_move(x, i);
			if (gt[x][i]!=' ') {
				if (gc[x][i]==his_color) gpk_insert_valid_move(x, i);
				flag++;
			}
			i--;
		}

		// -- slide right --
		flag=0; i=x+1;
		while ((flag==0)&&(i<8)) {
			if (gt[i][y]==' ') gpk_insert_valid_move(i, y);
			if (gt[i][y]!=' ') {
				if (gc[i][y]==his_color) gpk_insert_valid_move(i, y);
				flag++;
			}
			i++;
		}

		// -- slide left --
		flag=0; i=x-1;
		while ((flag==0)&&(i>=0)) {
			if (gt[i][y]==' ') gpk_insert_valid_move(i, y);
			if (gt[i][y]!=' ') {
				if (gc[i][y]==his_color) gpk_insert_valid_move(i, y);
				flag++;
			}
			i--;
		}
	}

	if ((gt[x][y]=='B')||(gt[x][y]=='Q')) { // ---------------- BISHOP + QUEEN ----- ALFIERE + REGINA -----------------

		// -- down right --
		flag=0; i=x+1; j=y+1;
		while ((flag==0)&&(i<8)&&(j<8)) {
			if (gt[i][j]==' ') gpk_insert_valid_move(i, j);
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_valid_move(i, j);
				flag++;
			}
			i++; j++;
		}

		// -- down left --
		flag=0; i=x-1; j=y+1;
		while ((flag==0)&&(i>=0)&&(j<8)) {
			if (gt[i][j]==' ') gpk_insert_valid_move(i, j);
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_valid_move(i, j);
				flag++;
			}
			i--; j++;
		}

		// -- up left --
		flag=0; i=x-1; j=y-1;
		while ((flag==0)&&(i>=0)&&(j>=0)) {
			if (gt[i][j]==' ') gpk_insert_valid_move(i, j);
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_valid_move(i, j);
				flag++;
			}
			i--; j--;
		}

		// -- up right --
		flag=0; i=x+1; j=y-1;
		while ((flag==0)&&(i<8)&&(j>=0)) {
			if (gt[i][j]==' ') gpk_insert_valid_move(i, j);
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_valid_move(i, j);
				flag++;
			}
			i++; j--;
		}
	}
	}

	return valid_move_cnt;
}


/* ***** CERCA MOSSE MIGLIORI DA UNA POSIZIONE DATA ***** */
int gpk_compute_best_moves(int x, int y) {

	int i,j,flag;
	int my_color=((gc[x][y]==1)?1:2);
	int his_color=((gc[x][y]==1)?2:1);

	best_move_cnt=0;

	for (i=0;i<28;i++) {
		best_move[i][0]=0;
		best_move[i][1]=0;
	}

	if (gt[x][y]=='K') { // ------------------- R E -----------------------
		
		// --- normali ---
		if ((x<7)&&(gc[x+1][y]==his_color)) gpk_insert_best_move(x+1, y);
		if ((x>0)&&(gc[x-1][y]==his_color)) gpk_insert_best_move(x-1, y);
		if ((y>0)&&(gc[x][y-1]==his_color)) gpk_insert_best_move(x, y-1);
		if ((y<7)&&(gc[x][y+1]==his_color)) gpk_insert_best_move(x, y+1);

		// --- diagonali ---
		if ((x<7)&&(y<7)&&(gc[x+1][y+1]==his_color)) gpk_insert_best_move(x+1, y+1);
		if ((x>0)&&(y>0)&&(gc[x-1][y-1]==his_color)) gpk_insert_best_move(x-1, y-1);
		if ((x<7)&&(y>0)&&(gc[x+1][y-1]==his_color)) gpk_insert_best_move(x+1, y-1);
		if ((x>0)&&(y<7)&&(gc[x-1][y+1]==his_color)) gpk_insert_best_move(x-1, y+1);
	}

	if (gt[x][y]=='H') { // ------------------- C A V A L L O -----------------------
		
		if ((x<7)&&(y<6)&&(gc[x+1][y+2]==his_color)) gpk_insert_best_move(x+1, y+2);
		if ((x<6)&&(y<7)&&(gc[x+2][y+1]==his_color)) gpk_insert_best_move(x+2, y+1);
		if ((x>0)&&(y>1)&&(gc[x-1][y-2]==his_color)) gpk_insert_best_move(x-1, y-2);
		if ((x>1)&&(y>0)&&(gc[x-2][y-1]==his_color)) gpk_insert_best_move(x-2, y-1);
		if ((x>0)&&(y<6)&&(gc[x-1][y+2]==his_color)) gpk_insert_best_move(x-1, y+2);
		if ((x<6)&&(y>0)&&(gc[x+2][y-1]==his_color)) gpk_insert_best_move(x+2, y-1);
		if ((x<7)&&(y>1)&&(gc[x+1][y-2]==his_color)) gpk_insert_best_move(x+1, y-2);
		if ((x>1)&&(y<7)&&(gc[x-2][y+1]==his_color)) gpk_insert_best_move(x-2, y+1);
	}

	if (gt[x][y]=='p') { // ------------------- P E D O N E -----------------------
		
		if (gc[x][y]==1) { // ----- NERO -----
			if ((x<7)&&(y<7)&&(gc[x+1][y+1]==2)) gpk_insert_best_move(x+1, y+1); // mangia a destra
			if ((x>0)&&(y<7)&&(gc[x-1][y+1]==2)) gpk_insert_best_move(x-1, y+1); // mangia a sinistra
		}
		if (gc[x][y]==2) { // ----- ROSSO -----
			if ((x<7)&&(y>0)&&(gc[x+1][y-1]==1)) gpk_insert_best_move(x+1, y-1); // mangia a destra
			if ((x>0)&&(y>0)&&(gc[x-1][y-1]==1)) gpk_insert_best_move(x-1, y-1); // mangia a sinistra
		}
	}

	if ((gt[x][y]=='T')||(gt[x][y]=='Q')) { // ------------------- T O R R E  /  R E G I N A -----------------------

		// -- scende --
		flag=0; i=y+1;
		while ((flag==0)&&(i<8)) {
			if (gt[x][i]!=' ') {
				if (gc[x][i]==his_color) gpk_insert_best_move(x, i);
				flag++;
			}
			i++;
		}

		// -- sale --
		flag=0; i=y-1;
		while ((flag==0)&&(i>=0)) {
			if (gt[x][i]!=' ') {
				if (gc[x][i]==his_color) gpk_insert_best_move(x, i);
				flag++;
			}
			i--;
		}

		// -- slide DX --
		flag=0; i=x+1;
		while ((flag==0)&&(i<8)) {
			if (gt[i][y]!=' ') {
				if (gc[i][y]==his_color) gpk_insert_best_move(i, y);
				flag++;
			}
			i++;
		}

		// -- slide SX --
		flag=0; i=x-1;
		while ((flag==0)&&(i>=0)) {
			if (gt[i][y]!=' ') {
				if (gc[i][y]==his_color) gpk_insert_best_move(i, y);
				flag++;
			}
			i--;
		}
	}

	if ((gt[x][y]=='B')||(gt[x][y]=='Q')) { // ------------------- A L F I E R E  /  R E G I N A -----------------------

		// -- DOWN DX --
		flag=0; i=x+1; j=y+1;
		while ((flag==0)&&(i<8)&&(j<8)) {
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_best_move(i, j);
				flag++;
			}
			i++; j++;
		}

		// -- DOWN SX --
		flag=0; i=x-1; j=y+1;
		while ((flag==0)&&(i>=0)&&(j<8)) {
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_best_move(i, j);
				flag++;
			}
			i--; j++;
		}

		// -- UP SX --
		flag=0; i=x-1; j=y-1;
		while ((flag==0)&&(i>=0)&&(j>=0)) {
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_best_move(i, j);
				flag++;
			}
			i--; j--;
		}

		// -- UP DX --
		flag=0; i=x+1; j=y-1;
		while ((flag==0)&&(i<8)&&(j>=0)) {
			if (gt[i][j]!=' ') {
				if (gc[i][j]==his_color) gpk_insert_best_move(i, j);
				flag++;
			}
			i++; j--;
		}
	}
	return best_move_cnt;
}


/* ***** FIND MOVES & DO IT ***** */
void gpk_actor_game(int x, int y, GtkWidget *button) {
	
	gchar temp[32];
	int changed=0;
	
	temp[31]=0;
	if ((stato==0)||(stato==10)||(stato==20)||(stato==22)) {                      // -1- TAKE UP THE CHIP.....
		while (stato_r>0) usleep(DELAY_PRE_COMPUTE); // wait robot movement to be finished
		if (stato==10) gpk_compute_best_moves(x,y);  // If autoplay search best moves
		if (gpk_compute_valid_moves(x,y)>0) {        // ....however search valid moves
			//gpk_dump_valid_moves();
			mossa[0]=x;
			mossa[1]=y;
			gpk_backup_colors();
			gpk_alternate_colors();
			stato++;
			changed++;
		}
	}
	if (((stato==1)||(stato==11)||(stato==21)||(stato==23))&&(changed==0)) {      // -2- PUT IT ON THE CHECKBOARD
		while (stato_r>0) usleep(DELAY_PRE_COMPUTE2); // wait robot movement to be finished 
		if (stato==23) usleep(DELAY_SHOW_OTHER_MOVE); // wait to let human see the move (if needed)
		gpk_recovery_colors();
		if (arrocco_started) {
			if ((x==6)&&(y==0)) y=10; // conventional position for castling
			if ((x==6)&&(y==7)) y=11; // conventional position for castling
			arrocco_started=0;
		}
		if (gpk_check_this_move(x,y)) {
			if (y>9) {                            // if castling required, do it
				gpk_do_arrocco(gc[mossa[0]][mossa[1]]);
			} else {                              // ....else do normal move
				if (gt[mossa[0]][mossa[1]]=='K') arrocco_flag[(gc[mossa[0]][mossa[1]]==2)?1:0]=0;
				if (gc[x][y]>0) gpk_update_num_chips((gc[mossa[0]][mossa[1]]), gt[x][y]);
				// ----- update array -----
				gt[x][y]=gt[mossa[0]][mossa[1]];
				gc[x][y]=gc[mossa[0]][mossa[1]];
				gt[mossa[0]][mossa[1]]=' ';
				gc[mossa[0]][mossa[1]]=0;
				// ----- move robot -----
				x1=mossa[0];
				y1=mossa[1];
				x2=x;
				y2=y;
				stato_r=5;
				actual_player++;
			}
			snprintf(temp, 31, "%c%c%d \n", gt[x][y], 65+x2, y2);
			gpk_update_history((GtkButton *)button, temp); // update history
		} else {
			if (stato==21) stato--;
			//actual_player++;
		}
		if (stato==20) {
			//stato++;
		} else if (stato==21) {
			stato++;
		} else if (stato==23) {
			stato=20;
		} else {
			stato--;
		}
		gpk_automata();
		num_mosse++;
		//actual_player++;
		if (actual_player>2) actual_player=1;
	}
	//gpk_draw_position(button);
	gpk_update_stats((GtkButton *)button);
	gpk_check_gameover((GtkButton *)button);
	gpk_update_chessboard((GtkButton *)button);
	//gpk_dump_chessboard((GtkButton *)button);
	//gtk_widget_focus_out(button); // ----------------- Toglie la selezione BLU dalla scacchiera ------------------
}


/* ***** Wrapper to put characters od checkboard ***** */
void gpk_set_checkboard(GtkButton *button, int x, int y, gchar val, int colore) {
	
	gchar temp[3];
	gchar target[12];
	GtkStyle *style;

	temp[2]=0;
	target[11]=0;
	snprintf(temp, 2, "%c", val);
	snprintf(target, 11, "entry%d", (short)(26+x+(y*8)));

	GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), target);
	gtk_entry_set_text(GTK_ENTRY(gwidget), temp);

	// ***** Draw white squares on checkboard
	if (((x-y)%2)==0) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_white;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Draw black squares on checkboard
	if (((x-y)%2)!=0) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_lgrey;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw red color chip fonts
	if (gc[x][y]==2) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->text[0]=col_red;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw black color chip fonts
	if (gc[x][y]==1) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->text[0]=col_black;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw possible moves on background
	if (colore==3) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_yellow;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw possible captures on background
	if (colore==4) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_purple;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw possible captures on background
	if (colore==5) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_green;
		gtk_widget_set_style(gwidget, style);
	}

	// ***** Dwaw actual position on background
	if (colore==7) {
		style=gtk_widget_get_style(gwidget);
		style=gtk_style_copy(style); //Saw this one in a mailing-list :)
		style->base[0]=col_orange;
		gtk_widget_set_style(gwidget, style);
	}
}


/* ***** RESET BUTTON ***** */
void on_button65_clicked (GtkButton *button, gpointer user_data) {

	vittorie[0]=0;
	vittorie[1]=0;
	if (cold_start) {
		g_print("\nCold start initiated....\n");
		gpk_game_reset(button);
		cold_start=0;
	} else {
		warm_start=1;
		g_print("\nWarm start initiated....\n");
	}
	if (stato==0) {
		gpk_clear_history(button); // moved here to let history stay after autoplay and clear only manually
	} else {
		stato=0;
	}
	gpk_update_chessboard(button);
	gpk_update_stats(button);
}


/* ***** 2 PLAYERS BUTTON ***** */
void on_button66_clicked (GtkButton *button, gpointer user_data) {

	timer_on=1;
	last_game=2;
	message_blink_threshold=10;
	snprintf(message_string, 31, "Play free chess");
	gpk_clear_history(button);
	g_print ("Call 2 Players\n");
}


/* ***** 1 PLAYER BUTTON ***** */
void on_button67_clicked (GtkButton *button, gpointer user_data) {

	timer_on=1;
	last_game=1;
	message_blink_threshold=10;
	snprintf(message_string, 31, "You are black");
	g_print ("Call 1 Players\n");
	stato=20;
	gpk_clear_history(button);
	if (thread_started==0) {
		pthread_create(&thd1, NULL, gpk_thread, button);
		g_print ("Thread started now....\n");
		thread_started++;
	}
	g_print ("Thread informaed to start game....\n");
}


/* ***** 0 PLAYERS BUTTON ***** */
void on_button68_clicked (GtkButton *button, gpointer user_data) {

	timer_on=1;
	last_game=0;
	message_blink_threshold=10;
	snprintf(message_string, 31, "Autoplay");
	g_print ("Call 0 Players\n");
	stato=10;
	gpk_clear_history(button);
	if (thread_started==0) {
		pthread_create(&thd1, NULL, gpk_thread, button);
		g_print ("Thread started now....\n");
		thread_started++;
	}
	g_print ("Thread informaed to start game....\n");
}


/* ***** AUTOPLAY THREAD ***** */
void *gpk_thread(void *arg) {

	int x,y,r;
	GtkButton *button=(GtkButton *)arg;

	g_print ("Autoplay Thread UP and RUNNING !!\n");
	while (1) {
		while ((stato==9)||(stato==10)||(stato==22)||(stato==23)) {
			g_print ("Hit....");
			valid_chip_cnt=gpk_find_chips(actual_player);
			if (valid_chip_cnt>0) {
				x=valid_chip[(int)(random()%valid_chip_cnt)][0];
				y=valid_chip[(int)(random()%valid_chip_cnt)][1];
				while (stato_r>0) usleep(DELAY_THREAD_WAIT_MOVE);  //             !! WARNING DEADLOCK !!
				gdk_threads_enter();
				gpk_actor_game(x, y, (GtkWidget *)button);
				gdk_threads_leave();
				usleep(DELAY_THREAD_BETWEEN_MOVE);
				if ((best_move_cnt>0)&&(valid_move_cnt==0)) g_print(" ==> PASSO <==\n");
				if ((best_move_cnt>0)&&(valid_move_cnt>0)) {                         // ----- search good (capturing) move -----
					//r=(int)(random()%best_move_cnt);
					while (stato_r>0) usleep(DELAY_THREAD_WAIT_MOVE2);  //    !! WARNING DEADLOCK !!
					gdk_threads_enter();
					gpk_actor_game(best_move[0][0], best_move[0][1], (GtkWidget *)button);
					gdk_threads_leave();
					g_print (" GOOD move found !!\n");
				} else if (valid_move_cnt>0) {                  // -------- ...if no good move, take a random valid one --------
					r=(int)(random()%valid_move_cnt);
					while (stato_r>0) usleep(DELAY_THREAD_WAIT_MOVE3);  //    !! WARNING DEADLOCK !!
					gdk_threads_enter();
					gpk_actor_game(valid_move[r][0], valid_move[r][1], (GtkWidget *)button);
					gdk_threads_leave();
					g_print (" valid found\n");
				} else {
					g_print (" miss\n");
				}
			} else {
				g_print ("NO CHIPS (You would not be here !!)\n");
			}
		}
		usleep(DELAY_THREAD_BETWEEN_PLAYERS);
	}
	g_print ("THREAD END (You would not be here !!)\n");
}


/* ***** DRAW AREA / MOVE ROBOT THREAD ***** */
void *gpk_thread2(void *arg) {
	
	int stato_old;                              // stato[1..49] ==> move    stato[50..99] ==> capture 
	int player=0;
	gchar temp[35];
	GtkButton *here=(GtkButton *)arg;

	temp[34]=0;
	g_print ("J-Robot Thread UP and RUNNING !!\n");
	while (1) {
		while (stato_r>0) {                               // ----- state: wait -----
			stato_old=stato_r;
			if (stato_old==5) {                       // ----- state: capture check -----
				if (gt1[x2][y2]==' ') {
					stato_r=7;
				} else {
					stato_r=50;
					player=((gc1[x1][y1]==1)?1:0);
				}
			}
			
			// ----- under here: movement states -----
			
			if (stato_old==7) {                       // ----- state: acceleration -----
				if (xx<(x1+xo)) xx++;
				if (yy<(y1+yo)) yy++;
				if ((xx==(x1+xo))&&(yy==(y1+yo))) stato_r=10;
			}
			if (stato_old==10) {                      // ----- state: go down on chip -----
				if (zz<zo) { zz++; } else { stato_r=11; }
			}
			if (stato_old==11) {                      // ----- state: take the chip -----
				tt=gt1[x1][y1];
				ct=gc1[x1][y1];
				gt1[x1][y1]=' ';
				gc1[x1][y1]=0;
				stato_r=12;
			}
			if (stato_old==12) {                      // ----- state: take up chip -----
				if (zz>0) { zz--; } else { stato_r=15; }
			}
			if (stato_old==15) {                      // ----- state: take away the chip -----
				if (xx!=(x2+xo)) {
					if (xx<(x2+xo)) { xx++; } else { xx--; }
				}
				if (yy!=(y2+yo)) {
					if (yy<(y2+yo)) { yy++; } else { yy--; }
				}
				if ((xx==(x2+xo))&&(yy==(y2+yo))) stato_r=16;
			}
			if (stato_old==16) {                      // ----- state: take down the chip -----
				if (zz<zo) { zz++; } else { stato_r=18; }
			}
			if (stato_old==18) {                      // ----- state: leave the chip -----
				gt1[x2][y2]=tt;
				gc1[x2][y2]=ct;
				tt=' ';
				ct=0;
				stato_r=19;
			}
			if (stato_old==19) {                      // ----- state: move up -----
				if (zz>0) { zz--; } else { stato_r=20; }
			}
			if (stato_old==20) {                      // ----- state: return -----
				if (xx>0) xx--;
				if (yy>0) yy--;
				if ((xx==0)&&(yy==0)) stato_r=30; // ----- state: the end -----
			}
			
			// ----- under here: capturing states -----
			
			if (stato_old==50) {                       // ----- state: acceleration -----
				if (xx<(x2+xo)) xx++;
				if (yy<(y2+yo)) yy++;
				if ((xx==(x2+xo))&&(yy==(y2+yo))) stato_r=55;
			}
			if (stato_old==55) {                      // ----- state: go down to the chip -----
				if (zz<zo) { zz++; } else { stato_r=60; }
			}
			if (stato_old==60) {                      // ----- state: take the chip -----
				tt=gt1[x2][y2];
				ct=gc1[x2][y2];
				gt1[x2][y2]=' ';
				gc1[x2][y2]=0;
				stato_r=65;
			}
			if (stato_old==65) {                      // ----- state: take up the chip -----
				if (zz>0) { zz--; } else { stato_r=70; }
			}
			if (stato_old==70) {                       // ----- state: take the chip to the storage -----
				if (xx!=(xd[player])) {
					if (xx<(xd[player])) { xx++; } else { xx--; }
				}
				if (yy!=(yd[player])) {
					if (yy<(yd[player])) { yy++; } else { yy--; }
				}
				if ((xx==(xd[player]))&&(yy==(yd[player]))) stato_r=75;
			}
			if (stato_old==75) {                      // ----- state: take down the chip to the storage -----
				if (zz<zo) { zz++; } else { stato_r=80; }
			}
			if (stato_old==80) {                      // ----- state: leave the chip -----
				dt[player][mangiate[player]]=tt;
				tt=' ';
				ct=0;
				stato_r=85;
			}
			if (stato_old==85) {                      // ----- state: go up -----
				if (zz>0) { zz--; } else { stato_r=90; }
			}
			if (stato_old==90) {                       // ----- state: go to source -----
				if (xx!=(x1+xo)) {
					if (xx<(x1+xo)) { xx++; } else { xx--; }
				}
				if (yy!=(y1+yo)) {
					if (yy<(y1+yo)) { yy++; } else { yy--; }
				}
				if ((xx==(x1+xo))&&(yy==(y1+yo))) stato_r=95;
			}
			if (stato_old==95) {                      // ----- state: go down to the chip -----
				if (zz<zo) { zz++; } else { stato_r=100; }
			}
			if (stato_old==100) {                      // ----- state: take the chip -----
				tt=gt1[x1][y1];
				ct=gc1[x1][y1];
				gt1[x1][y1]=' ';
				gc1[x1][y1]=0;
				stato_r=105;
			}
			if (stato_old==105) {                      // ----- state: take up the chip -----
				if (zz>0) { zz--; } else { stato_r=110; }
			}
			if (stato_old==110) {                       // ----- state: take away the chip -----
				if (xx!=(x2+xo)) {
					if (xx<(x2+xo)) { xx++; } else { xx--; }
				}
				if (yy!=(y2+yo)) {
					if (yy<(y2+yo)) { yy++; } else { yy--; }
				}
				if ((xx==(x2+xo))&&(yy==(y2+yo))) stato_r=115;
			}
			if (stato_old==115) {                      // ----- state: move down the chip -----
				if (zz<zo) { zz++; } else { stato_r=120; }
			}
			if (stato_old==120) {                      // ----- state: leave the chip -----
				gt1[x2][y2]=tt;
				gc1[x2][y2]=ct;
				tt=' ';
				ct=0;
				stato_r=125;
			}
			if (stato_old==125) {                      // ----- state: go up -----
				if (zz>0) { zz--; } else { stato_r=130; }
			}
			if (stato_old==130) {                      // ----- state: return -----
				if (xx>0) xx--;
				if (yy>0) yy--;
				if ((xx==0)&&(yy==0)) stato_r=135;
			}
			if (stato_old==135) {                      // ----- state: update stats -----
				xd[player]++;
				if (xd[player]>16) {
					yd[player]++;
					xd[player]=9;
				}
				mangiate[player]++;
				stato_r=30;                        // ----- state: the end -----
			}
			
			/* ***** PANIC BUTTON PRESSED ? ***** */
			while (game_paused==1) {
				usleep(DELAY_THREAD_WAIT_MOVE);
			}
			
			/* ***** GUI UPDATE ***** */
			gdk_threads_enter();
				gpk_update_stat_num(here, 1, stato_r);
				gpk_update_stat_num(here, 5, xx);
				gpk_update_stat_num(here, 6, yy);
				gpk_draw_position(here);
				gpk_draw_position2(here);
			gdk_threads_leave();
			
			//snprintf(temp, 34, "Stato_r[%d][%d]: %d\n", xx, yy, stato_r);
			//g_print (temp);
			/*
			if (stato_r>49) {
				usleep(DELAY_THREAD2_BETWEEN_STATES_SLOW);
			} else {
				usleep(DELAY_THREAD2_BETWEEN_STATES);
			}
			*/
			usleep(DELAY_THREAD2_BETWEEN_STATES);
			if (stato_r==30) stato_r=0;              // ----- state: quiet -----
			
			/* ***** MOVE JOSHUA !! ***** */
			//outb((int)((xx%256)|((yy%256)*16)), 0);
			gdk_threads_enter();
				gpk_outb((GtkWidget *)here, translate_bit[xx], 0);
				gpk_outb((GtkWidget *)here, translate_bit[yy], 1);
				gpk_outb((GtkWidget *)here, translate_bit[zz], 2);
			gdk_threads_leave();
		}
		usleep(DELAY_THREAD2_BETWEEN_STATES2);
	}
	g_print ("THREAD END (You would not be here !!)\n");
}


/* ***** MESSAGES / TIMERS THREAD ***** */
void *gpk_thread3(void *arg) {
	
	int x,y,r,tot_time;
	GtkButton *button=(GtkButton *)arg;
	gchar temp1[16];
	gchar temp2[16];
	gchar temp3[16];
	
	temp1[15]=0;
	temp2[15]=0;
	temp3[15]=0;
	g_print ("Message Thread UP and RUNNING !!\n");
	while (1) {
		
		/* ***** BLINK MESSAGES ***** */
		gdk_threads_enter();
			if (message_hilight>0) {
				gpk_update_stat_str(button, 24, "");
				message_hilight=0;
			} else {
				gpk_update_stat_str(button, 24, message_string);
				message_hilight=1;
			}
		gdk_threads_leave();
		if (message_blink_threshold>0) {
			message_blink_threshold--;
			usleep(DELAY_THREAD3_BETWEEN_HILIGHT_FAST);
		} else {
			usleep(DELAY_THREAD3_BETWEEN_HILIGHT_SLOW);
			
			/* ***** UPDATE TIMERS ***** */
			if (timer_on) {
				timer[actual_player-1]++;
			}
		}
		tot_time=timer[0]+timer[1];
		snprintf(temp1, 15, "%02d:%02d", (int)timer[0]/60, (int)timer[0]%60);
		snprintf(temp2, 15, "%02d:%02d", (int)timer[1]/60, (int)timer[1]%60);
		snprintf(temp3, 15, "%02d:%02d", (int)tot_time/60, (int)tot_time%60);
		gdk_threads_enter();
			gpk_update_stat_str(button, 98, temp1);
			gpk_update_stat_str(button, 99, temp2);
			gpk_update_stat_str(button, 100, temp3);
		gdk_threads_leave();
	}
	g_print ("THREAD END (You would not be here !!)\n");
}


/* ***** CHAT MESSAGE FETCH - THREAD ***** */
void *gpk_thread4(void *arg) {
	
	gchar mtmp[32];
	gchar msg[1000];
	gchar nick[16];      // Must be 12
	int i,n;
	int cnt=0;
	GtkButton *button=(GtkButton *)arg;
	
	g_print ("Network Thread UP and RUNNING !!\n");
	while (1) {
	//	g_print ("==> gpk_thread4 <==\n");
		//gpk_curl_fetch(button, "http://joshua.gipoco.com/msgserv.php?cmd=ping&session=1122334412345678&nick=hhkk&ver=0.1.5a", 2);
		gdk_threads_enter();
			/*
			if (chunk.size>0) {
				n=chunk.size;
				if (n>999) { n=999; }
				memset(chunk.memory, 0, 1000);
				snprintf(msg, n, "%s\n", chunk.memory);
				gpk_update_chat(button, msg);
			}
			*/
		//gpk_curl_free(2);
			if (need_refresh_list>0) {
				gpk_clear_community_treeview(button);
				snprintf(message_string, 31, "Choose num players"); // Prewrite message for the next phase
	 			gpk_populate_community_treeview(button);
				need_refresh_list=0;
			}
			if (warm_start>0) {
				g_print("\nWarm start pending !!");
				if (stato_r==0) {
					g_print("\nWarm start EXECUTED !!\n\n");
					warm_start=0;
					gpk_game_reset(button);
					gpk_update_stats((GtkButton *)button);
					gpk_update_chessboard((GtkButton *)button);
				}
			}
		gdk_threads_leave();
		usleep(DELAY_THREAD4_NETWORK_WAIT);
	}
	g_print ("THREAD END (You would not be here !!)\n");
}


/* ***** HOOK SIGNALS CALLBACKS ***** */
gboolean on_entry1_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) { g_print ("Call GG\n"); return FALSE; }

gboolean on_entry26_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 0, widget);
		return FALSE;
	}
}
gboolean on_entry27_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 0, widget);
		return FALSE;
	}
}
gboolean on_entry28_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 0, widget);
		return FALSE;
	}
}
gboolean on_entry29_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 0, widget);
		return FALSE;
	}
}
gboolean on_entry30_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 0, widget);
		return FALSE;
	}
}
gboolean on_entry31_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 0, widget);
		return FALSE;
	}
}
gboolean on_entry32_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 0, widget);
		return FALSE;
	}
}
gboolean on_entry33_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 0, widget);
		return FALSE;
	}
}


gboolean on_entry34_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 1, widget);
		return FALSE;
	}
}
gboolean on_entry35_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 1, widget);
		return FALSE;
	}
}
gboolean on_entry36_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 1, widget);
		return FALSE;
	}
}
gboolean on_entry37_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 1, widget);
		return FALSE;
	}
}
gboolean on_entry38_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 1, widget);
		return FALSE;
	}
}
gboolean on_entry39_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 1, widget);
		return FALSE;
	}
}
gboolean on_entry40_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 1, widget);
		return FALSE;
	}
}
gboolean on_entry41_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 1, widget);
		return FALSE;
	}
}


gboolean on_entry42_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 2, widget);
		return FALSE;
	}
}
gboolean on_entry43_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 2, widget);
		return FALSE;
	}
}
gboolean on_entry44_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 2, widget);
		return FALSE;
	}
}
gboolean on_entry45_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 2, widget);
		return FALSE;
	}
}
gboolean on_entry46_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 2, widget);
		return FALSE;
	}
}
gboolean on_entry47_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 2, widget);
		return FALSE;
	}
}
gboolean on_entry48_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 2, widget);
		return FALSE;
	}
}
gboolean on_entry49_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 2, widget);
		return FALSE;
	}
}


gboolean on_entry50_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 3, widget);
		return FALSE;
	}
}
gboolean on_entry51_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 3, widget);
		return FALSE;
	}
}
gboolean on_entry52_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 3, widget);
		return FALSE;
	}
}
gboolean on_entry53_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 3, widget);
		return FALSE;
	}
}
gboolean on_entry54_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 3, widget);
		return FALSE;
	}
}
gboolean on_entry55_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 3, widget);
		return FALSE;
	}
}
gboolean on_entry56_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 3, widget);
		return FALSE;
	}
}
gboolean on_entry57_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 3, widget);
		return FALSE;
	}
}


gboolean on_entry58_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 4, widget);
		return FALSE;
	}
}
gboolean on_entry59_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 4, widget);
		return FALSE;
	}
}
gboolean on_entry60_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 4, widget);
		return FALSE;
	}
}
gboolean on_entry61_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 4, widget);
		return FALSE;
	}
}
gboolean on_entry62_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 4, widget);
		return FALSE;
	}
}
gboolean on_entry63_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 4, widget);
		return FALSE;
	}
}
gboolean on_entry64_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 4, widget);
		return FALSE;
	}
}
gboolean on_entry65_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 4, widget);
		return FALSE;
	}
}


gboolean on_entry66_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 5, widget);
		return FALSE;
	}
}
gboolean on_entry67_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 5, widget);
		return FALSE;
	}
}
gboolean on_entry68_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 5, widget);
		return FALSE;
	}
}
gboolean on_entry69_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 5, widget);
		return FALSE;
	}
}
gboolean on_entry70_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 5, widget);
		return FALSE;
	}
}
gboolean on_entry71_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 5, widget);
		return FALSE;
	}
}
gboolean on_entry72_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 5, widget);
		return FALSE;
	}
}
gboolean on_entry73_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 5, widget);
		return FALSE;
	}
}


gboolean on_entry74_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 6, widget);
		return FALSE;
	}
}
gboolean on_entry75_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 6, widget);
		return FALSE;
	}
}
gboolean on_entry76_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 6, widget);
		return FALSE;
	}
}
gboolean on_entry77_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 6, widget);
		return FALSE;
	}
}
gboolean on_entry78_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 6, widget);
		return FALSE;
	}
}
gboolean on_entry79_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 6, widget);
		return FALSE;
	}
}
gboolean on_entry80_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 6, widget);
		return FALSE;
	}
}
gboolean on_entry81_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 6, widget);
		return FALSE;
	}
}


gboolean on_entry82_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(0, 7, widget);
		return FALSE;
	}
}
gboolean on_entry83_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(1, 7, widget);
		return FALSE;
	}
}
gboolean on_entry84_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(2, 7, widget);
		return FALSE;
	}
}
gboolean on_entry85_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(3, 7, widget);
		return FALSE;
	}
}
gboolean on_entry86_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(4, 7, widget);
		return FALSE;
	}
}
gboolean on_entry87_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(5, 7, widget);
		return FALSE;
	}
}
gboolean on_entry88_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(6, 7, widget);
		return FALSE;
	}
}
gboolean on_entry89_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (stato_r==0) {
		gpk_actor_game(7, 7, widget);
		return FALSE;
	}
}






gboolean on_drawingarea1_button_press_event(GtkWidget *here, GdkEventButton *event, gpointer user_data) {
	g_print ("Josh\n");
	return FALSE;
}


gboolean on_button69_button_press_event(GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	if (game_paused==0) {
		game_paused=1;
	} else {
		game_paused=0;
	}
	return FALSE;
}


gboolean on_button70_button_press_event(GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
  return FALSE;
}


gboolean on_button71_button_press_event(GtkWidget *widget, GdkEventButton *event, gpointer user_data) {
	gpk_inject_board();
	g_print ("Development Board Injected !\n");
	return FALSE;
}


gboolean on_button72_button_press_event(GtkWidget *here, GdkEventButton *event, gpointer user_data) {
	gpk_draw_position((GtkButton *)here);
	gpk_draw_position2((GtkButton *)here);
	g_print ("Click\n");
	return FALSE;
}





void on_button82_clicked (GtkButton *button, gpointer user_data) {
	g_print ("Set 1\n");
}


void on_button83_clicked (GtkButton *button, gpointer user_data) {

	GtkTreeModel *model;
	GtkTreeIter new_row;
	GtkWidget *treeview=lookup_widget(GTK_WIDGET(button), "treeview1");

	model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
	gtk_list_store_append(GTK_LIST_STORE(model), &new_row);
	gtk_list_store_set(GTK_LIST_STORE(model), &new_row, COL_NAME, "GiPOCO", COL_AGE, "WAIT", -1);

	g_print ("Set 2\n");
}


void on_button86_clicked (GtkButton *button, gpointer user_data) {
	g_print ("Set 3\n");
}


/* ***** CURL WEB FETCHER ***** */
void gpk_curl_fetch(GtkButton *button, gchar *ttt, int debug) {
	
	int i,n;
	int cnt=0;
	gchar tmp[32];
	
	tmp[31]=0;
	snprintf(tmp, 31, "(%d) Requested XML\n", debug);
	g_print(tmp);
	while (gpk_curl_lock==1) {
		usleep(DELAY_CURL_LOCK);
	}
	snprintf(tmp, 31, "(%d) Fetching XML\n", debug);
	g_print(tmp);
	gpk_curl_lock=1;
	chunk.memory=NULL;
	chunk.size=0;
	curl_global_init(CURL_GLOBAL_ALL);
	curl_handle=curl_easy_init();
	curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, 1);
	curl_easy_setopt(curl_handle, CURLOPT_NOSIGNAL, 1);
	curl_easy_setopt(curl_handle, CURLOPT_CONNECTTIMEOUT, 3);
	//curl_easy_setopt(curl_handle, CURLOPT_TIMEOUT, 3);
	curl_easy_setopt(curl_handle, CURLOPT_URL, ttt);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, WriteMemoryCallback);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)&chunk);
	curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, "libcurl-agent/1.0");
	curl_easy_perform(curl_handle);
	curl_easy_cleanup(curl_handle);
	network_traf+=chunk.size+gpk_strlen(ttt)+45+100; // Update traffic with (download + upload + headers and overhead)
	gpk_update_stat_net_traf(button, network_traf);
	snprintf(tmp, 31, "(%d) Received XML\n", debug);
	g_print(tmp);
}


/* ***** FREE CURL MEMORY ***** */
void gpk_curl_free(int debug) {
	
	gchar tmp[32];
	
	tmp[31]=0;
	if (chunk.memory) {
		memset(chunk.memory, 0, chunk.size);
		free(chunk.memory);
	}
	gpk_curl_lock=0;
	snprintf(tmp, 31, "(%d) Free XML\n", debug);
	g_print(tmp);
}


/* ***** CHAT MESSAGE INJECT ***** */
void on_button98_clicked(GtkButton *button, gpointer user_data) {

	gchar *msg;
	gchar url[512];
	GtkWidget* gwidget=lookup_widget(GTK_WIDGET(button), "entry102");
/*
	msg=gtk_entry_get_text(gwidget);
	snprintf(url, 512, "http://joshua.gipoco.com/msgserv.php?cmd=talk&nick=test1&msg=%s", msg);
	g_print ("==> on_button98_clicked <==\n");
	gpk_curl_fetch(button, url, 3);
	gpk_update_stat_str(button, 102, "");
	gpk_curl_free(3);
	g_print ("Chat !!\n");

*/
}

